]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame_incremental - builder.sh
- add .cvsignore to PACKAGE/.cvsignore
[packages/rpm-build-tools.git] / builder.sh
... / ...
CommitLineData
1#!/bin/ksh
2#
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
6# -----------
7# Exit codes:
8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
20
21# Notes (todo/bugs):
22# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
23# - when Icon: field is present, -5 and -a5 doesn't work
24# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
25# TODO:
26# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
27
28RCSID='$Id$'
29r=${RCSID#* * }
30rev=${r%% *}
31VERSION="v0.23/$rev"
32VERSIONSTRING="\
33Build package utility from PLD Linux CVS repository
34$VERSION (C) 1999-2009 Free Penguins".
35
36PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
37
38COMMAND="build"
39TARGET=""
40
41SPECFILE=""
42BE_VERBOSE=""
43QUIET=""
44CLEAN=""
45DEBUG=""
46NOURLS=""
47NOCVS=""
48NOCVSSPEC=""
49NODIST=""
50NOINIT=""
51PREFMIRRORS=""
52UPDATE=""
53ADD5=""
54NO5=""
55ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
56CVSROOT=""
57GREEDSRC=""
58
59# use rpm 4.4.6+ digest format instead of comments if non-zero
60USEDIGEST=
61
62# user agent when fetching files
63USER_AGENT="PLD/Builder($VERSION)"
64
65# It can be used i.e. in log file naming.
66# See LOGFILE example.
67DATE=`date +%Y-%m-%d_%H-%M-%S`
68
69# Example: LOGFILE='../log.$PACKAGE_NAME'
70# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
71# Yes, you can use variable name! Note _single_ quotes!
72LOGFILE=''
73
74LOGDIR=""
75LOGDIROK=""
76LOGDIRFAIL=""
77LASTLOG_FILE=""
78
79CHMOD="no"
80CHMOD_MODE="0644"
81RPMOPTS=""
82RPMBUILDOPTS=""
83BCOND=""
84GROUP_BCONDS="no"
85
86# create symlinks for tools in PACKAGE_DIR, see get_spec()
87SYMLINK_TOOLS="yes"
88
89PATCHES=""
90SOURCES=""
91ICONS=""
92PACKAGE_RELEASE=""
93PACKAGE_VERSION=""
94PACKAGE_NAME=""
95ASSUMED_NAME=""
96PROTOCOL="ftp"
97WGET_RETRIES=${MAX_WGET_RETRIES:-0}
98
99CVS_COMMAND=${CVS_COMMAND:-cvs}
100CVS_FORCE=""
101CVSIGNORE_DF="yes"
102CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
103CVS_SERVER="cvs.pld-linux.org"
104CVSTAG=""
105
106RES_FILE=""
107
108DISTFILES_SERVER="://distfiles.pld-linux.org"
109ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
110
111DEF_NICE_LEVEL=19
112SCHEDTOOL="auto"
113
114FAIL_IF_NO_SOURCES="yes"
115
116# let get_files skip over files which are present to get those damn files fetched
117SKIP_EXISTING_FILES="no"
118
119TRY_UPGRADE=""
120# should the specfile be restored if upgrade failed?
121REVERT_BROKEN_UPGRADE="yes"
122
123if rpm --specsrpm 2>/dev/null; then
124 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
125 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
126else
127 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
128 if [ -x /usr/bin/rpm-getdeps ]; then
129 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
130 else
131 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
132 fi
133fi
134
135
136# Here we load saved user environment used to
137# predefine options set above, or passed to builder
138# in command line.
139# This one reads global system environment settings:
140if [ -f ~/etc/builderrc ]; then
141 . ~/etc/builderrc
142fi
143# And this one cascades settings using user personal
144# builder settings.
145# Example of ~/.builderrc:
146#
147#UPDATE_POLDEK_INDEXES="yes"
148#FETCH_BUILD_REQUIRES="yes"
149#REMOVE_BUILD_REQUIRES="force"
150#GROUP_BCONDS="yes"
151#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
152#TITLECHANGE=no
153#
154SU_SUDO=""
155if [ -n "$HOME_ETC" ]; then
156 USER_CFG="$HOME_ETC/.builderrc"
157 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
158else
159 USER_CFG=~/.builderrc
160 BUILDER_MACROS=~/.builder-rpmmacros
161fi
162
163[ -f "$USER_CFG" ] && . "$USER_CFG"
164
165if [ "$SCHEDTOOL" = "auto" ]; then
166 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
167 SCHEDTOOL="schedtool -B -e"
168 else
169 SCHEDTOOL="no"
170 fi
171fi
172
173if [ -n "$USE_PROZILLA" ]; then
174 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
175 GETURI2="$GETURI"
176 OUTFILEOPT="-O"
177elif [ -n "$USE_AXEL" ]; then
178 GETURI="axel -a $AXEL_OPTS"
179 GETURI2="$GETURI"
180 OUTFILEOPT="-o"
181else
182 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
183 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
184 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
185 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
186
187 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
188 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
189 OUTFILEOPT="-O"
190fi
191
192GETLOCAL="cp -a"
193
194if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
195 RPM="rpm"
196 RPMBUILD="rpm"
197else
198 RPM="rpm"
199 RPMBUILD="rpmbuild"
200fi
201
202#
203# are we using cvs-nserver ?
204#
205CVS_NSERVER=0
206$CVS_COMMAND --version 2>&1 | grep -q 'CVS-nserver'
207[ $? -eq 0 ] && CVS_NSERVER=1
208
209POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
210POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
211
212run_poldek() {
213 RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
214 if [ -n "$LOGFILE" ]; then
215 LOG=`eval echo $LOGFILE`
216 if [ -n "$LASTLOG_FILE" ]; then
217 echo "LASTLOG=$LOG" > $LASTLOG_FILE
218 fi
219 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
220 return $exit_pldk
221 else
222 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
223 return `cat ${RES_FILE}`
224 rm -rf ${RES_FILE}
225 fi
226}
227
228#---------------------------------------------
229# functions
230
231usage() {
232 if [ -n "$DEBUG" ]; then set -xv; fi
233 echo "\
234Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|-ba|--build]
235[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
236[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
237[-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
238[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
239[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
240[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}] [--use-greed-sources]
241[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
242[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
243<package>[.spec][:cvstag]
244
245-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
246-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
247-n5, --no-md5 - ignore md5 comments in spec
248-D, --debug - enable builder script debugging mode,
249-debug - produce rpm debug package (same as --opts -debug)
250-V, --version - output builder version string
251--short-version - output builder short version
252-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
253-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
254 from <package>.spec,
255-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
256 only package from <package>.spec,
257-bp, --build-prep - execute the %prep phase of <package>.spec,
258-bc - execute the %build phase of <package>.spec,
259-bi - execute the %install phase of <package>.spec
260-bl - execute the %files phase of <package>.spec
261-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
262 them into src.rpm,
263--short-circuit - short-circuit build
264-B, --branch - add branch
265-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
266 SPECS and \$RPM_BUILD_ROOT and CVS/Entries) after rpmbuild commands.
267-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
268 SPECS and \$RPM_BUILD_ROOT and CVS/Entries). Doesn't run
269 any rpm building.
270-cf, --cvs-force - use -F when tagging (useful when moving branches)
271-d <cvsroot>, --cvsroot <cvsroot>
272 - setup \$CVSROOT,
273--define <macro> <value>
274 - define a macro <macro> with value <value>,
275--alt_kernel <kernel>
276 - same as --define 'alt_kernel <kernel>'
277--nodeps - rpm won't check any dependences
278-g, --get - get <package>.spec and all related files from CVS repo
279 or HTTP/FTP,
280-h, --help - this message,
281--http - use http instead of ftp,
282-l <logfile>, --logtofile <logfile>
283 - log all to file,
284-nc, --no-cvs - don't download sources from CVS, if source URL is given,
285-ncs, --no-cvs-specs
286 - don't check specs in CVS
287-nd, --no-distfiles - don't download from distfiles
288-nm, --no-mirrors - don't download from mirror, if source URL is given,
289-nu, --no-urls - don't try to download from FTP/HTTP location,
290-ns, --no-srcs - don't download Sources
291-ns0, --no-source0 - don't download Source0
292-nn, --no-net - don't download anything from the net
293-pm, --prefer-mirrors - prefer mirrors (if any) over distfiles for SOURCES
294--no-init - don't initialize builder paths (SPECS and SOURCES)
295-ske,
296--skip-existing-files - skip existing files in get_files
297--opts <rpm opts> - additional options for rpm
298-q, --quiet - be quiet,
299--date yyyy-mm-dd - build package using resources from specified CVS date,
300-r <cvstag>, --cvstag <cvstag>
301 - build package using resources from specified CVS tag,
302-A - build package using CVS resources as any sticky tags/date/kopts being reset.
303-R, --fetch-build-requires
304 - fetch what is BuildRequired,
305-RB, --remove-build-requires
306 - remove all you fetched with -R or --fetch-build-requires
307 remember, this option requires confirmation,
308-FRB, --force-remove-build-requires
309 - remove all you fetched with -R or --fetch-build-requires
310 remember, this option works without confirmation,
311-sd, --source-distfiles - list sources available from distfiles (intended for offline
312 operations; does not work when Icon field is present
313 but icon file is absent),
314-sc, --source-cvs - list sources available from CVS
315-sdp, --source-distfiles-paths - list sources available from distfiles -
316 paths relative to distfiles directory (intended for offline
317 operations; does not work when Icon field is present
318 but icon file is absent),
319-sf, --source-files - list sources - bare filenames (intended for offline
320 operations; does not work when Icon field is present
321 but icon file is absent),
322-sp, --source-paths - list sources - filenames with full local paths (intended for
323 offline operations; does not work when Icon field is present
324 but icon file is absent),
325-su, --source-urls - list urls - urls to sources and patches
326 intended for copying urls with spec with lots of macros in urls
327-T <cvstag> , --tag <cvstag>
328 - add cvs tag <cvstag> for files,
329-Tvs, --tag-version-stable
330 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
331-Ts, --tag-stable
332 - add cvs tag STABLE for files,
333-Tv, --tag-version
334 - add cvs tag NAME-VERSION-RELEASE for files,
335-Tp, --tag-prefix <prefix>
336 - add <prefix> to NAME-VERSION-RELEASE tags,
337-tt, --test-tag <prefix>
338 - fail if tag is already present,
339-ir, --integer-release-only
340 - allow only integer and snapshot releases
341-v, --verbose - be verbose,
342-u, --try-upgrade - check version, and try to upgrade package
343-un, --try-upgrade-with-float-version
344 - as above, but allow float version
345--use-greed-sources
346 - try download source from tag head if don't find it in
347 current tag
348-U, --update - refetch sources, don't use distfiles, and update md5 comments
349-Upi, --update-poldek-indexes
350 - refresh or make poldek package index files.
351-np, --nopatch <patchnumber>
352 - don't apply <patchnumber>
353--show-bconds - show available conditional builds, which can be used
354 - with --with and/or --without switches.
355--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
356 ./repackage.sh script. in other words, the output is
357 parseable by scripts.
358--with/--without <feature>
359 - conditional build package depending on %_with_<feature>/
360 %_without_<feature> macro switch. You may now use
361 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
362 constructions. Set GROUP_BCONDS to yes to make use of it.
363--target <platform>, --target=<platform>
364 - build for platform <platform>.
365--init-rpm-dir - initialize ~/rpm directory structure
366"
367}
368
369# change dependency to specname
370# common changes:
371# - perl(Package::Name) -> perl-Package-Name
372depspecname() {
373 local package="$1"
374
375 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g}')
376 echo "$package"
377}
378
379update_shell_title() {
380 [ -t 1 ] || return
381 local len=${COLUMNS:-80}
382 local msg=$(echo "$*" | cut -c-$len)
383
384 if [ -n "$BE_VERBOSE" ]; then
385 echo >&2 "$(date +%s.%N) $*"
386 fi
387
388 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
389 local pkg
390 if [ -n "$PACKAGE_NAME" ]; then
391 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
392 else
393 pkg=${SPECFILE}
394 fi
395
396 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
397 msg=$(echo $msg | tr -d '\n\r')
398 case "$TERM" in
399 cygwin|xterm*)
400 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
401 ;;
402 screen*)
403 echo >&2 -ne "\033]0;$msg\007"
404 ;;
405 esac
406 fi
407}
408
409# set TARGET from BuildArch: from SPECFILE
410set_spec_target() {
411 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
412 tmp=$(awk '/^BuildArch:/ { print $NF}' $ASSUMED_NAME/$SPECFILE)
413 if [ "$tmp" ]; then
414 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
415 TARGET="$tmp"
416 case "$RPMBUILD" in
417 "rpmbuild")
418 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
419 "rpm")
420 TARGET_SWITCH="--target=$TARGET" ;;
421 esac
422 fi
423 fi
424}
425
426# runs rpm with minimal macroset
427minirpm() {
428 # we reset macros not to contain macros.build as all the %() macros are
429 # executed here, while none of them are actually needed.
430 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
431 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
432
433 # TODO: move these to /usr/lib/rpm/macros
434 cat > $BUILDER_MACROS <<'EOF'
435%x8664 x86_64 amd64 ia32e
436%alt_kernel %{nil}
437%_alt_kernel %{nil}
438%requires_releq_kernel_up %{nil}
439%requires_releq_kernel_smp %{nil}
440%requires_releq_kernel %{nil}
441%requires_releq() %{nil}
442%pyrequires_eq() %{nil}
443%requires_eq() %{nil}
444%requires_eq_to() %{nil}
445%releq_kernel_up ERROR
446%releq_kernel_smp ERROR
447%releq_kernel ERROR
448%kgcc_package ERROR
449%_fontsdir ERROR
450%ruby_version ERROR
451%ruby_ver_requires_eq() %{nil}
452%ruby_mod_ver_requires_eq() %{nil}
453%__php_api_requires() %{nil}
454%php_major_version ERROR
455%php_api_version ERROR
456%requires_xorg_xserver_extension %{nil}
457%requires_xorg_xserver_xinput %{nil}
458%requires_xorg_xserver_font %{nil}
459%requires_xorg_xserver_videodrv %{nil}
460%py_ver ERROR
461%perl_vendorarch ERROR
462%perl_vendorlib ERROR
463# damn. need it here! - copied from /usr/lib/rpm/macros.build
464%tmpdir %(echo "${TMPDIR:-/tmp}")
465%patchset_source(f:b:) %(
466 base=%{-b*}%{!-b*:10000};
467 start=$(expr $base + %1);
468 end=$(expr $base + %{?2}%{!?2:%{1}});
469 # we need to call seq twice as it doesn't allow two formats
470 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
471 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
472 paste %{tmpdir}/__ps{1,2};
473 rm -f %{tmpdir}/__ps{1,2};
474) \
475%{nil}
476%add_etc_shells(p) %{p:<lua>}
477%remove_etc_shells(p) %{p:<lua>}
478%lua_add_etc_shells() %{nil}
479%lua_remove_etc_shells() %{nil}
480EOF
481 if [ "$NOINIT" = "yes" ] ; then
482 cat >> $BUILDER_MACROS <<'EOF'
483%_specdir ./
484%_sourcedir ./
485EOF
486 fi
487 eval $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
488}
489
490cache_rpm_dump() {
491 if [ -n "$DEBUG" ]; then
492 set -x
493 set -v
494 fi
495
496 if [ -x /usr/bin/rpm-specdump ]; then
497 update_shell_title "cache_rpm_dump using rpm-specdump command"
498 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND $SPECFILE)
499 else
500 update_shell_title "cache_rpm_dump using rpmbuild command"
501 local rpm_dump
502 rpm_dump=`
503 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
504 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
505 case "$RPMBUILD" in
506 rpm)
507 ARGS='-bp'
508 ;;
509 rpmbuild)
510 ARGS='--nodigest --nosignature --nobuild'
511 ;;
512 esac
513 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
514 `
515 if [ $? -gt 0 ]; then
516 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
517 echo "$error" >&2
518 Exit_error err_build_fail
519 fi
520
521 # make small dump cache
522 rpm_dump_cache=`echo "$rpm_dump" | awk '
523 $2 ~ /^SOURCEURL/ {print}
524 $2 ~ /^PATCHURL/ {print}
525 $2 ~ /^nosource/ {print}
526 $2 ~ /^PACKAGE_/ {print}
527 '`
528 fi
529
530 update_shell_title "cache_rpm_dump: OK!"
531}
532
533rpm_dump() {
534 if [ -z "$rpm_dump_cache" ] ; then
535 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
536 fi
537 echo "$rpm_dump_cache"
538}
539
540get_icons() {
541 update_shell_title "get icons"
542 ICONS=$(awk '/^Icon:/ {print $2}' ${ASSUMED_NAME}/${SPECFILE})
543 if [ -z "$ICONS" ]; then
544 return
545 fi
546
547 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
548}
549
550parse_spec() {
551 update_shell_title "parsing specfile"
552 if [ -n "$DEBUG" ]; then
553 set -x
554 set -v
555 fi
556
557 # icons are needed for successful spec parse
558 get_icons
559
560 cd $PACKAGE_DIR
561 cache_rpm_dump
562
563 if [ "$NOSRCS" != "yes" ]; then
564 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
565 fi
566
567 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
568 FAIL_IF_NO_SOURCES="no"
569 fi
570
571 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
572 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
573 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
574 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
575 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
576
577 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
578 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
579 fi
580
581 if [ -n "$BE_VERBOSE" ]; then
582 echo "- Sources : `nourl $SOURCES`"
583 if [ -n "$PATCHES" ]; then
584 echo "- Patches : `nourl $PATCHES`"
585 else
586 echo "- Patches : *no patches needed*"
587 fi
588 if [ -n "$ICONS" ]; then
589 echo "- Icon : `nourl $ICONS`"
590 else
591 echo "- Icon : *no package icon*"
592 fi
593 echo "- Name : $PACKAGE_NAME"
594 echo "- Version : $PACKAGE_VERSION"
595 echo "- Release : $PACKAGE_RELEASE"
596 fi
597
598 update_shell_title "parse_spec: OK!"
599}
600
601Exit_error() {
602 if [ -n "$DEBUG" ]; then
603 set -x
604 set -v
605 fi
606
607 cd "$__PWD"
608
609 case "$1" in
610 "err_no_spec_in_cmdl" )
611 remove_build_requires
612 echo >&2 "ERROR: spec file name not specified."
613 exit 2 ;;
614 "err_invalid_cmdline" )
615 echo >&2 "ERROR: invalid command line arg ($2)."
616 exit 2 ;;
617 "err_no_spec_in_repo" )
618 remove_build_requires
619 echo >&2 "Error: spec file not stored in CVS repo."
620 exit 3 ;;
621 "err_no_source_in_repo" )
622 remove_build_requires
623 echo >&2 "Error: some source, patch or icon files not stored in CVS repo. ($2)"
624 exit 4 ;;
625 "err_build_fail" )
626 remove_build_requires
627 echo >&2 "Error: package build failed. (${2:-no more info})"
628 exit 5 ;;
629 "err_no_package_data" )
630 remove_build_requires
631 echo >&2 "Error: couldn't get out package name/version/release from spec file."
632 exit 6 ;;
633 "err_tag_exists" )
634 remove_build_requires
635 echo >&2 "Tag ${2} already exists (spec release: ${3})."
636 exit 9 ;;
637 "err_fract_rel" )
638 remove_build_requires
639 echo >&2 "Release ${2} not integer and not a snapshot."
640 exit 10 ;;
641 "err_branch_exists" )
642 remove_build_requires
643 echo >&2 "Tree branch already exists (${2})."
644 exit 11 ;;
645 "err_acl_deny" )
646 remove_build_requires
647 echo >&2 "Error: conditions reject building this spec (${2})."
648 exit 12 ;;
649 esac
650 echo >&2 "Unknown error."
651 exit 100
652}
653
654init_builder() {
655 if [ -n "$DEBUG" ]; then
656 set -x
657 set -v
658 fi
659
660 if [ "$NOINIT" != "yes" ] ; then
661 TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
662 REPO_DIR=$TOP_DIR/packages
663 PACKAGE_DIR=$TOP_DIR/packages/$ASSUMED_NAME
664 else
665 REPO_DIR="."
666 PACKAGE_DIR="."
667 fi
668
669 __PWD=$(pwd)
670}
671
672get_spec() {
673
674 update_shell_title "get_spec"
675
676 if [ -n "$DEBUG" ]; then
677 set -x
678 set -v
679 fi
680
681 cd "$REPO_DIR"
682 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
683 SPECFILE="$(basename $SPECFILE .spec).spec"
684 fi
685 if [ "$NOCVSSPEC" != "yes" ]; then
686
687 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
688 echo "Warning: No CVS access defined - using local .spec file"
689 NOCVSSPEC="yes"
690 fi
691
692 if [ -d "$ASSUMED_NAME" ]; then
693 cvsup "$ASSUMED_NAME/$SPECFILE" || Exit_error err_no_spec_in_repo
694 else
695 cvsup -c -d $ASSUMED_NAME "packages/$ASSUMED_NAME/$SPECFILE" || Exit_error err_no_spec_in_repo
696
697 # remove Entries.Static -- so 'cvs up' would update all files in a repo
698 rm "$ASSUMED_NAME/CVS/Entries.Static"
699 cvsignore_df .cvsignore
700
701 # create symlinks for tools
702 if [ "$SYMLINK_TOOLS" != "no" ]; then
703 for a in dropin md5 adapter builder {relup,compile,repackage}.sh; do
704 [ -f $a ] || continue
705 ln -s ../$a $ASSUMED_NAME
706 cvsignore_df $a
707 done
708 fi
709 fi
710 fi
711
712 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
713 Exit_error err_no_spec_in_repo
714 fi
715
716 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
717 chmod $CHMOD_MODE $ASSUMED_NAME/$SPECFILE
718 fi
719 unset OPTIONS
720 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $ASSUMED_NAME/$SPECFILE
721
722 set_spec_target
723}
724
725find_mirror() {
726 cd "$REPO_DIR"
727 local url="$1"
728 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
729 $CVS_COMMAND update mirrors >&2
730 fi
731
732 IFS="|"
733 local origin mirror name rest ol prefix
734 while read origin mirror name rest; do
735 # skip comments and empty lines
736 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
737 continue
738 fi
739 ol=$(echo -n "$origin" | wc -c)
740 prefix=$(echo -n "$url" | head -c $ol)
741 if [ "$prefix" = "$origin" ] ; then
742 suffix=$(echo "$url" | cut -b $((ol+1))-)
743 echo -n "$mirror$suffix"
744 return 0
745 fi
746 done < mirrors
747 echo "$url"
748}
749
750# Warning: unpredictable results if same URL used twice
751src_no() {
752 cd $PACKAGE_DIR
753 rpm_dump | \
754 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
755 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
756 head -n 1 | xargs
757}
758
759src_md5() {
760 [ "$NO5" = "yes" ] && return
761 no=$(src_no "$1")
762 [ -z "$no" ] && return
763 cd $PACKAGE_DIR
764 local md5
765
766 if [ -f additional-md5sums ]; then
767 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
768 if [ -z "$spec_rev" ]; then
769 spec_rev=$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')
770 fi
771 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
772 md5=$(grep -s -v '^#' additional-md5sums | \
773 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
774 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
775 grep -E '^[0-9a-f]{32}$')
776
777 if [ "$md5" ]; then
778 if [ $(echo "$md5" | wc -l) != 1 ] ; then
779 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
780 fi
781 echo "$md5" | tail -n 1
782 return
783 fi
784 fi
785
786 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
787 if [ -n "$source_md5" ]; then
788 echo $source_md5
789 else
790 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
791 if [ -n "$source_md5" ]; then
792 echo $source_md5
793 else
794 # we have empty SourceX-md5, but it is still possible
795 # that we have NoSourceX-md5 AND NoSource: X
796 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
797 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
798 echo $nosource_md5
799 fi
800 fi
801 fi
802}
803
804distfiles_path() {
805 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
806}
807
808distfiles_url() {
809 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
810}
811
812distfiles_attic_url() {
813 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
814}
815
816good_md5() {
817 md5=$(src_md5 "$1")
818 [ "$md5" = "" ] || \
819 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
820}
821
822good_size() {
823 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
824 [ -n "$size" -a "$size" -gt 0 ]
825}
826
827cvsignore_df() {
828 if [ "$CVSIGNORE_DF" != "yes" ]; then
829 return
830 fi
831 cvsignore=${PACKAGE_DIR}/.cvsignore
832 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
833 echo "$1" >> $cvsignore
834 fi
835}
836
837cvsup() {
838 update_shell_title "cvsup"
839 local OPTIONS="up "
840
841 if [ "$1" = "-c" ]; then
842 OPTIONS="co "
843 shift
844 fi
845 if [ -n "$CVSROOT" ]; then
846 OPTIONS="-d $CVSROOT $OPTIONS"
847 fi
848
849 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
850 OPTIONS="$OPTIONS -A"
851 else
852 if [ -n "$CVSDATE" ]; then
853 OPTIONS="$OPTIONS -D $CVSDATE"
854 fi
855 if [ -n "$CVSTAG" ]; then
856 OPTIONS="$OPTIONS -r $CVSTAG"
857 fi
858 fi
859
860 local result=1
861 local retries_counter=0
862 if [ $# = 1 ]; then
863 update_shell_title "cvsup: $*"
864 else
865 update_shell_title "cvsup: $# files"
866 fi
867 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
868 retries_counter=$(( $retries_counter + 1 ))
869 output=$(LC_ALL=C $CVS_COMMAND $OPTIONS "$@" 2>&1)
870 result=$?
871 [ -n "$output" ] && echo "$output"
872 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
873 echo "Trying again [$*]... ($retries_counter)"
874 update_shell_title "cvsup: retry #$retries_counter"
875 sleep 2
876 continue
877 else
878 break
879 fi
880 done
881 update_shell_title "cvsup: done!"
882 return $result
883}
884
885# returns true if "$1" is ftp, http or https protocol url
886is_url() {
887 case "$1" in
888 ftp://*|http://*|https://*)
889 return 0
890 ;;
891 esac
892 return 1
893}
894
895update_md5() {
896 if [ $# -eq 0 ]; then
897 return
898 fi
899
900 update_shell_title "update md5"
901 if [ -n "$DEBUG" ]; then
902 set -x
903 set -v
904 fi
905
906 cd "$PACKAGE_DIR"
907
908 # pass 1: check files to be fetched
909 local todo
910 local need_files
911 for i in "$@"; do
912 local fp=$(nourl "$i")
913 local srcno=$(src_no "$i")
914 if [ -n "$ADD5" ]; then
915 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
916 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE && continue
917 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE && continue
918 else
919 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE || continue
920 fi
921 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
922 need_files="$need_files $i"
923 fi
924 done
925
926 # pass 1a: get needed files
927 if [ "$need_files" ]; then
928 get_files $need_files
929 fi
930
931 # pass 2: proceed with md5 adding or updating
932 for i in "$@"; do
933 local fp=$(nourl "$i")
934 local srcno=$(src_no "$i")
935 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE )
936 if [ -z "$md5" ]; then
937 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE )
938 fi
939 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
940 local tag="# Source$srcno-md5:\t"
941 if [[ "$md5" == *NoSource* ]]; then
942 tag="# NoSource$srcno-md5:\t"
943 elif [ -n "$USEDIGEST" ]; then
944 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
945 fi
946 md5=$(md5sum "$fp" | cut -f1 -d' ')
947 echo "Updating Source$srcno ($md5: $fp)."
948 perl -i -ne '
949 print unless (/^\s*#\s*(No)?Source'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
950 print "'"$tag$md5"'\n" if /^Source'$srcno'\s*:\s+/;
951 ' \
952 $PACKAGE_DIR/$SPECFILE
953 fi
954 done
955}
956
957check_md5() {
958 [ "$NO5" = "yes" ] && return
959
960 update_shell_title "check md5"
961
962 for i in "$@"; do
963 if good_md5 "$i" && good_size "$i"; then
964 continue
965 fi
966
967 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
968 echo "or -5 to update md5 sums, if you're sure files are correct."
969 Exit_error err_no_source_in_repo $i
970 done
971}
972
973get_files() {
974 update_shell_title "get_files"
975
976 if [ -n "$DEBUG" ]; then
977 set -x
978 set -v
979 fi
980
981 if [ $# -gt 0 ]; then
982 cd "$PACKAGE_DIR"
983
984 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
985 echo "Warning: No CVS access defined for SOURCES"
986 NOCVS="yes"
987 fi
988
989 local nc=0
990 local get_files_cvs=""
991 for i in "$@"; do
992 nc=$((nc + 1))
993 local cvsup=0
994 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
995 update_shell_title "$i"
996 local fp=`nourl "$i"`
997 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
998 continue
999 fi
1000
1001 FROM_DISTFILES=0
1002 local srcmd5=$(src_md5 "$i")
1003
1004 # we know if source/patch is present in cvs/distfiles
1005 # - has md5 (in distfiles)
1006 # - in cvs... ideas?
1007
1008 # CHECK: local file didn't exist or always cvs up (first) requested.
1009 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
1010 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1011 echo "Warning: no URL given for $i"
1012 fi
1013
1014 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
1015 if good_md5 "$i" && good_size "$i"; then
1016 echo "$fp having proper md5sum already exists"
1017 continue
1018 fi
1019 target="$fp"
1020
1021 # optionally prefer mirror over distfiles if there's mirror
1022 # TODO: build url list and then try each url from the list
1023 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
1024 url="$im"
1025 else
1026 url=$(distfiles_url "$i")
1027 fi
1028
1029 url_attic=$(distfiles_attic_url "$i")
1030 FROM_DISTFILES=1
1031 # is $url local file?
1032 if [[ "$url" = [./]* ]]; then
1033 update_shell_title "${GETLOCAL%% *}: $url"
1034 ${GETLOCAL} $url $target
1035 else
1036 if [ -z "$NOMIRRORS" ]; then
1037 url=$(find_mirror "$url")
1038 fi
1039
1040 local uri=${url}
1041 # make shorter message for distfiles urls
1042 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1043 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1044 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1045 uri="df: $uri"
1046 fi
1047 update_shell_title "${GETURI%% *}: $uri"
1048 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
1049 if [ "`echo $url | grep -E 'ftp://'`" ]; then
1050 update_shell_title "${GETURI2%% *}: $url"
1051 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
1052 fi
1053 fi
1054
1055 # is it empty file?
1056 if [ ! -s "$target" ]; then
1057 rm -f "$target"
1058 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
1059 update_shell_title "${GETLOCAL%% *}: $url_attic"
1060 ${GETLOCAL} $url_attic $target
1061 else
1062 if [ -z "$NOMIRRORS" ]; then
1063 url_attic=$(find_mirror "$url_attic")
1064 fi
1065 update_shell_title "${GETURI%% *}: $url_attic"
1066 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
1067 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
1068 update_shell_title "${GETURI2%% *}: $url_attic"
1069 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
1070 fi
1071 fi
1072 fi
1073
1074 if [ -s "$target" ]; then
1075 cvsignore_df $target
1076 else
1077 rm -f "$target"
1078 FROM_DISTFILES=0
1079 fi
1080 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
1081 if [ $# -gt 1 ]; then
1082 get_files_cvs="$get_files_cvs $fp"
1083 update_shell_title "$fp (will cvs up later)"
1084 cvsup=1
1085 else
1086 cvsup $fp
1087 fi
1088 fi
1089
1090 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
1091 if [ -z "$NOMIRRORS" ]; then
1092 im=$(find_mirror "$i")
1093 else
1094 im="$i"
1095 fi
1096 update_shell_title "${GETURI%% *}: $im"
1097 ${GETURI} "$im" || \
1098 if [ "`echo $im | grep -E 'ftp://'`" ]; then
1099 update_shell_title "${GETURI2%% *}: $im"
1100 ${GETURI2} "$im"
1101 fi
1102 fi
1103
1104 if [ "$cvsup" = 1 ]; then
1105 continue
1106 fi
1107
1108 fi
1109
1110 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
1111 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
1112 if [ -n "GREEDSRC" ]; then
1113 get_greed_sources $i
1114 else
1115 Exit_error err_no_source_in_repo $i
1116 fi
1117 fi
1118
1119 # we check md5 here just only to refetch immediately
1120 if good_md5 "$i" && good_size "$i"; then
1121 :
1122 elif [ "$FROM_DISTFILES" = 1 ]; then
1123 # wrong md5 from distfiles: remove the file and try again
1124 # but only once ...
1125 echo "MD5 sum mismatch. Trying full fetch."
1126 FROM_DISTFILES=2
1127 rm -f $target
1128 update_shell_title "${GETURI%% *}: $url"
1129 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
1130 if [ "`echo $url | grep -E 'ftp://'`" ]; then
1131 update_shell_title "${GETURI2%% *}: $url"
1132 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
1133 fi
1134 if [ ! -s "$target" ]; then
1135 rm -f "$target"
1136 update_shell_title "${GETURI%% *}: $url_attic"
1137 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
1138 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
1139 update_shell_title "${GETURI2%% *}: $url_attic"
1140 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
1141 fi
1142 fi
1143 test -s "$target" || rm -f "$target"
1144 fi
1145 done
1146 SHELL_TITLE_PREFIX=""
1147
1148 if [ "$get_files_cvs" ]; then
1149 cvsup $get_files_cvs
1150 fi
1151
1152 if [ "$CHMOD" = "yes" ]; then
1153 CHMOD_FILES=$(nourl "$@")
1154 if [ -n "$CHMOD_FILES" ]; then
1155 chmod $CHMOD_MODE $CHMOD_FILES
1156 fi
1157 fi
1158 fi
1159}
1160
1161make_tagver() {
1162 if [ -n "$DEBUG" ]; then
1163 set -x
1164 set -v
1165 fi
1166
1167 # Check whether first character of PACKAGE_NAME is legal for tag name
1168 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1169 TAG_PREFIX=tag_
1170 fi
1171
1172 # NOTE: CVS tags may must not contain the characters `$,.:;@'
1173 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE | tr '[.@]' '[_#]')
1174
1175 # Remove #kernel.version_release from TAGVER because tagging sources
1176 # could occur with different kernel-headers than kernel-headers used at build time.
1177 # besides, %{_kernel_ver_str} is not expanded.
1178
1179 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1#%{_kernel_ver_str}
1180 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1181
1182 TAGVER=${TAGVER%#*}
1183 echo -n "$TAGVER"
1184}
1185
1186# bool is_tag_a_branch(tag)
1187#
1188# returns 1 if a tag is a branch set on SPECFILE
1189is_tag_a_branch() {
1190 if [ -n "$DEBUG" ]; then
1191 set -x
1192 set -v
1193 fi
1194
1195 if [ $# -ne 1 ]; then
1196 return 0;
1197 fi
1198
1199 TAG=$1
1200
1201 cd "$PACKAGE_DIR"
1202 $CVS_COMMAND status -v $SPECFILE | grep -Eiq "${TAG}.+(branch: [0-9.]+)"
1203 return $?
1204}
1205
1206tag_files() {
1207 TAG_FILES="$@"
1208
1209 if [ -n "$DEBUG" ]; then
1210 set -x
1211 set -v
1212 fi
1213
1214 echo "Version: $PACKAGE_VERSION"
1215 echo "Release: $PACKAGE_RELEASE"
1216
1217 local TAGVER
1218 if [ "$TAG_VERSION" = "yes" ]; then
1219 TAGVER=`make_tagver`
1220 echo "CVS tag: $TAGVER"
1221 fi
1222 if [ -n "$TAG" ]; then
1223 echo "CVS tag: $TAG"
1224 fi
1225
1226 local OPTIONS="tag $CVS_FORCE"
1227 if [ -n "$CVSROOT" ]; then
1228 OPTIONS="-d $CVSROOT $OPTIONS"
1229 fi
1230
1231 # if a tagname we are about to set already exists
1232 # and happens to be a branch (common case with AC-branch)
1233 # pass -B (allows -F to disturb branch tag)
1234 local _tag=$TAG
1235 if [ "$TAG_VERSION" = "yes" ]; then
1236 _tag=$TAGVER
1237 fi;
1238 is_tag_a_branch $_tag
1239 if [ $? -eq 0 -a $CVS_NSERVER -eq 0 ]; then
1240 OPTIONS="$OPTIONS -B"
1241 fi;
1242
1243 cd "$PACKAGE_DIR"
1244 local tag_files
1245 for i in $TAG_FILES; do
1246 # don't tag files stored on distfiles
1247 [ -n "`src_md5 $i`" ] && continue
1248 local fp=`nourl "$i"`
1249 if [ -f "$fp" ]; then
1250 tag_files="$tag_files $fp"
1251 elif [ -n "GREEDSRC" ]; then
1252 get_greed_sources $i
1253 else
1254 Exit_error err_no_source_in_repo $i
1255 fi
1256 done
1257
1258 if [ "$tag_files" ]; then
1259 if [ "$TAG_VERSION" = "yes" ]; then
1260 update_shell_title "tag sources: $TAGVER"
1261 printf "Tagging %d files\n" $(echo $tag_files | wc -w)
1262 $CVS_COMMAND $OPTIONS $TAGVER $tag_files || exit
1263 fi
1264 if [ -n "$TAG" ]; then
1265 update_shell_title "tag sources: $TAG"
1266
1267 while [ "$tag_files" ]; do
1268 local chunk=$(echo $tag_files | tr ' ' '\n' | head -n 100)
1269 printf "Tagging %d files\n" $(echo $chunk | wc -w)
1270 $CVS_COMMAND $OPTIONS $TAG $chunk || exit
1271 tag_files=$(echo $tag_files | tr ' ' '\n' | tail +101)
1272 done
1273 fi
1274 fi
1275
1276 cd "$PACKAGE_DIR"
1277 if [ "$TAG_VERSION" = "yes" ]; then
1278 update_shell_title "tag spec: $TAGVER"
1279 $CVS_COMMAND $OPTIONS $TAGVER $SPECFILE || exit
1280 fi
1281 if [ -n "$TAG" ]; then
1282 update_shell_title "tag spec: $TAG"
1283 $CVS_COMMAND $OPTIONS $TAG $SPECFILE || exit
1284 fi
1285}
1286
1287branch_files() {
1288 TAG=$1
1289 echo "CVS branch tag: $TAG"
1290 shift
1291
1292 TAG_FILES="$@"
1293
1294 if [ -n "$DEBUG" ]; then
1295 set -x
1296 set -v
1297 fi
1298
1299 local OPTIONS="tag $CVS_FORCE -b"
1300
1301 # branch exists?
1302 is_tag_a_branch $TAG
1303 if [ $? -eq 1 ]; then
1304 OPTIONS="$OPTIONS -B"
1305 fi
1306
1307 if [ -n "$CVSROOT" ]; then
1308 OPTIONS="-d $CVSROOT $OPTIONS"
1309 fi
1310 cd "$PACKAGE_DIR"
1311 local tag_files
1312 for i in $TAG_FILES; do
1313 local fp=`nourl "$i"`
1314 if [ -f "$fp" ]; then
1315 tag_files="$tag_files $fp"
1316 elif [ -n "GREEDSRC" ]; then
1317 get_greed_sources $i
1318 else
1319 Exit_error err_no_source_in_repo $i
1320 fi
1321 done
1322 if [ "$tag_files" ]; then
1323 $CVS_COMMAND $OPTIONS $TAG $tag_files || exit
1324 fi
1325
1326 cd "$PACKAGE_DIR"
1327 $CVS_COMMAND $OPTIONS $TAG $SPECFILE || exit
1328}
1329
1330
1331# this function should exit early if package can't be built for this arch
1332# this avoids unneccessary BR filling.
1333check_buildarch() {
1334 local out ret
1335 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
1336 ret=$?
1337 if [ $ret -ne 0 ]; then
1338 echo >&2 "$out"
1339 exit $ret
1340 fi
1341}
1342
1343build_package() {
1344 update_shell_title "build_package"
1345 if [ -n "$DEBUG" ]; then
1346 set -x
1347 set -v
1348 fi
1349
1350 cd "$PACKAGE_DIR"
1351
1352 if [ -n "$TRY_UPGRADE" ]; then
1353 update_shell_title "build_package: try_upgrade"
1354 if [ -n "$FLOAT_VERSION" ]; then
1355 TNOTIFY=$(./pldnotify.awk $SPECFILE -n) || exit 1
1356 else
1357 TNOTIFY=$(./pldnotify.awk $SPECFILE) || exit 1
1358 fi
1359
1360 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
1361
1362 if [ -n "$TNEWVER" ]; then
1363 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1364 echo "New version found, updating spec file to version " $TNEWVER
1365 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1366 cp -f $SPECFILE $SPECFILE.bak
1367 fi
1368 chmod +w $SPECFILE
1369 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
1370 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
1371 parse_spec
1372 NODIST="yes" get_files $SOURCES $PATCHES
1373 update_md5 $SOURCES
1374
1375 unset TOLDVER TNEWVER TNOTIFY
1376 fi
1377 fi
1378 cd "$PACKAGE_DIR"
1379
1380 case "$COMMAND" in
1381 build )
1382 BUILD_SWITCH="-ba" ;;
1383 build-binary )
1384 BUILD_SWITCH="-bb" ;;
1385 build-source )
1386 BUILD_SWITCH="-bs --nodeps" ;;
1387 build-prep )
1388 BUILD_SWITCH="-bp --nodeps" ;;
1389 build-build )
1390 BUILD_SWITCH="-bc" ;;
1391 build-install )
1392 BUILD_SWITCH="-bi" ;;
1393 build-list )
1394 BUILD_SWITCH="-bl" ;;
1395
1396 esac
1397
1398 update_shell_title "build_package: $COMMAND"
1399 if [ -n "$LOGFILE" ]; then
1400 LOG=`eval echo $LOGFILE`
1401 if [ -d "$LOG" ]; then
1402 echo "Log file $LOG is a directory."
1403 echo "Parse error in the spec?"
1404 Exit_error err_build_fail
1405 fi
1406 if [ -n "$LASTLOG_FILE" ]; then
1407 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1408 fi
1409 RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
1410
1411 (time eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
1412 RETVAL=`cat $RES_FILE`
1413 rm $RES_FILE
1414 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1415 if [ "$RETVAL" -eq "0" ]; then
1416 mv $LOG $LOGDIROK
1417 else
1418 mv $LOG $LOGDIRFAIL
1419 fi
1420 fi
1421 else
1422 eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE
1423 RETVAL=$?
1424 fi
1425 if [ "$RETVAL" -ne "0" ]; then
1426 if [ -n "$TRY_UPGRADE" ]; then
1427 echo "\n!!! Package with new version cannot be built automagically\n"
1428 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1429 mv -f $SPECFILE.bak $SPECFILE
1430 fi
1431 fi
1432 Exit_error err_build_fail
1433 fi
1434 unset BUILD_SWITCH
1435}
1436
1437nourl() {
1438 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1439}
1440
1441install_required_packages() {
1442 run_poldek -vi $1
1443 return $?
1444}
1445
1446find_spec_bcond() { # originally from /usr/lib/rpm/find-spec-bcond
1447 local SPEC="$1"
1448 awk -F"\n" '
1449 /^%changelog/ { exit }
1450 /^%bcond_with/{
1451 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1452 bcond = substr($0, RSTART + 6, RLENGTH - 6);
1453 gsub(/[ \t]+/, "_", bcond);
1454 print bcond
1455 }' $SPEC | LC_ALL=C sort -u
1456}
1457
1458process_bcondrc() {
1459 # expand bconds from ~/.bcondrc
1460 # The file structure is like gentoo's package.use:
1461 # ---
1462 # * -selinux
1463 # samba -mysql -pgsql
1464 # w32codec-installer license_agreement
1465 # php +mysqli
1466 # ---
1467 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
1468 :
1469 else
1470 return
1471 fi
1472
1473 SN=${SPECFILE%%\.spec}
1474
1475 local bcondrc=$HOME/.bcondrc
1476 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
1477
1478 local bcond_avail=$(find_spec_bcond $SPECFILE)
1479
1480 while read pkg flags; do
1481 # ignore comments
1482 [[ "$pkg" == \#* ]] && continue
1483
1484 # any package or current package?
1485 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1486 for flag in $flags; do
1487 local opt=${flag#[+-]}
1488
1489 # use only flags which are in this package.
1490 if [[ $bcond_avail = *${opt}* ]]; then
1491 if [[ $flag = -* ]]; then
1492 if [[ $BCOND != *--with?${opt}* ]]; then
1493 BCOND="$BCOND --without $opt"
1494 fi
1495 else
1496 if [[ $BCOND != *--without?${opt}* ]]; then
1497 BCOND="$BCOND --with $opt"
1498 fi
1499 fi
1500 fi
1501 done
1502 fi
1503 done < $bcondrc
1504 update_shell_title "parse ~/.bcondrc: DONE!"
1505}
1506
1507set_bconds_values() {
1508 update_shell_title "set bcond values"
1509
1510 AVAIL_BCONDS_WITHOUT=""
1511 AVAIL_BCONDS_WITH=""
1512
1513 if egrep -q '^# *_with' ${SPECFILE}; then
1514 echo >&2 "ERROR: This spec has old style bconds."
1515 exit 1
1516 fi
1517
1518 if ! grep -q '^%bcond' ${SPECFILE}; then
1519 return
1520 fi
1521
1522 local bcond_avail=$(find_spec_bcond $SPECFILE)
1523 process_bcondrc "$SPECFILE"
1524
1525 update_shell_title "parse bconds"
1526
1527 local opt bcond
1528 for opt in $bcond_avail; do
1529 case "$opt" in
1530 without_*)
1531 bcond=${opt#without_}
1532 if [[ "$BCOND" = *--without?${bcond}* ]]; then
1533 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$bcond>"
1534 else
1535 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $bcond"
1536 fi
1537 ;;
1538 with_*)
1539 bcond=${opt#with_}
1540 if [[ "$BCOND" = *--with?${bcond}* ]]; then
1541 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$bcond>"
1542 else
1543 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $bcond"
1544 fi
1545 ;;
1546 *)
1547 echo >&2 "ERROR: unexpected '$opt' in set_bconds_values"
1548 exit 1
1549 ;;
1550 esac
1551 done
1552}
1553
1554run_sub_builder() {
1555 package_name="${1}"
1556 update_shell_title "run_sub_builder $package_name"
1557 #
1558